#ifndef SIMULATION_HPP
#define SIMULATION_HPP

#include <vector>
#include <Body.hpp>
#include <BarnesHutTree.hpp>

namespace nbody {
	using namespace std;

	class Simulation {
	protected:
		int parallelSize;
		int parallelRank;
		int correctState;
		vector<Body> bodies;
		BarnesHutTree* tree;
	public:
		Simulation();
		virtual ~Simulation();
		virtual void initialize(string inputFile);
		virtual void cleanup();
		virtual void clearBodies();
		virtual void addBodies(vector<Body> bodies);
		virtual vector<Body> getBodies();
		virtual int getNumberOfProcesses();
		virtual int getProcessId();
		virtual bool readInputData(string filename);
		virtual Tree* getTree();
		virtual void runStep();
	};
}

#endif
